<!DOCTYPE html>
<html>
    <?php include_once('head.php'); ?>
    <body>
        <?php include_once('nav.php'); ?>

        <?php
            $success = FALSE;

            if ($_SERVER['REQUEST_METHOD'] == 'POST') {
                $amount = isset($_POST['amount']) && !empty($_POST['amount']) ? $_POST['amount'] : 1;
                $serialNumber = isset($_POST['serialnumber']) && !empty($_POST['serialnumber']) ? $_POST['serialnumber'] : NULL;
                $comment = isset($_POST['comment']) && !empty($_POST['comment']) ? $_POST['comment'] : NULL;

                $storage = DB::queryFirstRow('SELECT id,label,amount FROM storages WHERE label=%s', $_POST['storage']);

                if ($storage == NULL) {
                    DB::insert('storages', array('label' => $_POST['storage'], 'amount' => $amount));
                    $storage['id'] = DB::insertId();
                } else DB::update('storages', array('amount' => $storage['amount'] + $amount), 'id=%d', $storage['id']);

                $category = DB::queryFirstRow('SELECT id,amount FROM headCategories WHERE name=%s', $_POST['category']);
                if ($category == NULL) {
                    DB::insert('headCategories', array('name' => $_POST['category'], 'amount' => $amount));
                    $category['id'] = DB::insertId();
                } else DB::update('headCategories', array('amount' => $category['amount'] + $amount), 'id=%d', $category['id']);

                $item = DB::insert('items', array('label' => $_POST['label'], 'comment' => $comment, 'serialnumber' => $serialNumber, 'amount' => $amount, 'headcategory' => $category['id'], 'subcategories' => NULL, 'storageid' => $storage['id']));

                $success = TRUE;
            }
        ?>

        <div>
            <?php if ($success): ?>
            <div class="alert alert-info" role="alert">
                <p><?php echo $_POST['label'] ?> zur Datenbank hinzugefügt.</p>
            </div>
            <?php endif; ?>
            <form accept-charset="utf-8" method="POST" action="index.php" style="padding: 28px;">
                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text" id="basic-addon1">Bezeichnung</span>
                    </div>

                    <input type="text" name="label" maxlength="64" class="form-control" required="required" placeholder="Bezeichnung oder Name" aria-label="Gerätename" aria-describedby="basic-addon1">
                </div>

                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <div class="dropdown">
                            <select class="btn btn-secondary dropdown-toggle" type="button" tabindex="-1" id="storageDropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <option value="-1" selected="selected">Lagerplatz</option>
                                <?php
                                    $storages = DB::query('SELECT label FROM storages');
                                    foreach ($storages as $storage) {
                                        printf('<option value="%s">%s</option>', $storage['label'], $storage['label']);
                                    }
                                ?>
                            </select>
                        </div>
                    </div>

                    <input type="text" name="storage" id="storage" maxlength="32" class="form-control" placeholder="Lagerplatz" required="required">
                </div>

                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text" id="basic-addon7">Bemerkung</span>
                    </div>

                    <input type="text" name="comment" maxlength="255" class="form-control" placeholder="Bemerkung" aria-label="Bemerkung" aria-describedby="basic-addon7">
                </div>

                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <div class="dropdown">
                            <select class="btn btn-secondary dropdown-toggle" tabindex="-1" type="button" id="categoryDropdown" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    <option value="-1" selected="selected">Kategorie</option>
                                <?php
                                    $categories = DB::query('SELECT name FROM headCategories LIMIT 30');
                                    foreach ($categories as $category) {
                                        printf('<option value="%s">%s</option>', $category['name'], $category['name']);
                                    }
                                ?>
                            </select>
                        </div>
                    </div>

                    <input type="text" class="form-control" id="category" name="category" required="required" placeholder="Netzwerk/Hardware">

                </div>

                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text" id="basic-addon3">Unterkategorien</span>
                    </div>

                    <input type="text" class="form-control" name="subcategories" placeholder="Router,wlan,fritzBox" aria-label="Unterkategorien" aria-describedby="basic-addon3">
                </div>

                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text" id="basic-addon4">Anzahl</span>
                    </div>

                    <input type="text" name="amount" class="form-control" placeholder="1" aria-label="Anzahl" aria-describedby="basic-addon4">
                </div>

                <div class="input-group mb-3">
                    <div class="input-group-prepend">
                        <span class="input-group-text" id="basic-addon6">Seriennummer</span>
                    </div>

                    <input type="text" name="serialnumber" class="form-control" placeholder="Seriennummer/Artikelnummer" aria-label="Seriennummer" aria-describedby="basic-addon6">
                </div>

                <div style="float: right;">
                    <button type="submit" class="btn btn-primary">Eintragen</button>
                </div>
            </form>
        </div>

        <?php include_once('footer.php'); ?>
        <script type="text/javascript">
            document.querySelector('#storageDropdown').addEventListener('change', function(evt) {
                if (parseInt(evt.target.value) === -1) {
                    document.querySelector('#storage').value = ''
                    return
                }
                document.querySelector('#storage').value = evt.target.value;
            })

            document.querySelector('#categoryDropdown').addEventListener('change', function(evt) {
                if (parseInt(evt.target.value) === -1) {
                    document.querySelector('#category').value = ''
                    return
                }
                document.querySelector('#category').value = evt.target.value;
            })
        </script>
    </body>
</html>